#!/usr/bin/env node
const fs = require('fs');
const program = require('commander');
const download = require('download-git-repo');
const inquire = require('inquirer');
const handlebars = require('handlebars');
const ora = require('ora');
const chalk = require('chalk');
const symbols = require('log-symbols');
console('用于下载mor-react-template')
program.version('version :1.0.0', '-v ,--version')
    .command('init  <name>')
    .action((name) => {
        if (!fs.existsSync(name)) {
            inquire.prompt([
                { type: 'input', name: 'author', message: '请输入作者名称~' },
                {
                    name: 'description',
                    message: '请输入项目描述'
                },
            ]).then((answer) => {
                const spinner = ora('正在下载模板。。。')
                spinner.start();
                download('github:whales2333/react-template#master', name, { clone: true }, (err) => {
                    if (err) {
                        spinner.fail();
                        console.log(symbols.error, chalk.red(err));
                    } else {
                        spinner.succeed();

                        const meta = {
                            name,
                            description: answer.description,
                            author: answer.author
                        }
                        const fileName = `${name}/package.json`;
                        if (fs.existsSync(fileName)) {
                            const content = fs.readFileSync(fileName).toString();
                            const result = handlebars.compile(content)(meta);
                            fs.writeFileSync(fileName, result);
                        }
                        console.log(symbols.success, chalk.green('项目创建成功'));
                    }
                })
            })
        } else {
            console.log(symbols.error, chalk.red('项目已存在'));
        }
    })
program.parse(process.argv)